/* Copyright (c) 2013 BlackBerry Limited.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import bb.cascades 1.2

SceneCover {        
    content: Container {        
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill    
        background: Color.White
        
        ImageView {
            imageSource: "asset:///Images/water_drops_720.png"
            scalingMethod: ScalingMethod.AspectFill
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            attachedObjects: [ LayoutUpdateHandler { id: backgroundLuh }]
        }
        
        ImageView {
            imageSource: "asset:///Images/doo_neon_1064.png"
            scalingMethod: ScalingMethod.AspectFit
            maxHeight: backgroundLuh.layoutFrame.height * 0.7
            maxWidth: backgroundLuh.layoutFrame.width * 0.7
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
        }
    } 
} //  SceneCover
