import bb.cascades 1.2
import QTimer 1.0

Container {
    id: changelogContainer
    property alias changelogText: changelogLabel.text
    property int remainingSeconds: 10

    onCreationCompleted: { enableOkButtonTimer.start() }
    
    attachedObjects: [
        QTimer {
            id: enableOkButtonTimer
            interval: 1000
            onTimeout: { 
                remainingSeconds-- 
                if (remainingSeconds == 0) {
                    enableOkButtonTimer.stop()
                }
            }
        }
    ]

    layout: DockLayout {}
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Fill
    
    Container {
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        ScrollView {
            id: changelogScrollview
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            Container {
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                topPadding: _ui.du(5)
                bottomPadding: topPadding
                leftPadding: topPadding
                rightPadding: topPadding
                Container {
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    background: Color.Black
                    topPadding: _ui.du(1)
                    bottomPadding: topPadding
                    leftPadding: topPadding
                    rightPadding: topPadding
                    Container {
                        horizontalAlignment: HorizontalAlignment.Center
                        verticalAlignment: VerticalAlignment.Center
                        background: Color.White
                        topPadding: _ui.du(3)
                        bottomPadding: topPadding
                        leftPadding: topPadding
                        rightPadding: topPadding
                        Label {
                            text: qsTr("Changelog") + Retranslate.onLocaleOrLanguageChanged
                            textStyle.fontSize: FontSize.XXLarge
                            horizontalAlignment: HorizontalAlignment.Center
                        }
                        Label {
                            id: changelogLabel
                            multiline: true
                            horizontalAlignment: HorizontalAlignment.Center
                            textStyle.textAlign: TextAlign.Justify
                            content.flags: TextContentFlag.ActiveText
                        }
                        Button {
                            text: ((remainingSeconds > 0) ? remainingSeconds : qsTr("OK") + Retranslate.onLocaleOrLanguageChanged)
                            enabled: (remainingSeconds <= 0)
                            horizontalAlignment: HorizontalAlignment.Center
                            onClicked: {
                                changelogScrollview.scrollToPoint(0, 0)
                                changelogSheet.close()
                            }
                        }
                    }
                }
            }
        }
    }
}
