import bb.cascades 1.2

ImageView {
    id: imageView
    imageSource: "asset:///Images/background.jpg"
    minWidth: 2560
    minHeight: 1600
    animations: [
        TranslateTransition {
            id: translateAnimation
            easingCurve: StockCurve.SineInOut
            onEnded: { imageView.startAnimation() }
        }
    ]
    onCreationCompleted: {  
        imageView.startAnimation() 
        Application.fullscreen.connect(imageView.startAnimation)
        Application.thumbnail.connect(translateAnimation.stop)
    }
    
    function startAnimation() {
        var maxBorderWidth = _app.deviceInfo.deviceWidth / 4
        var randomBorderWidth = Math.random() * maxBorderWidth
        var toX = 0
        if (translationX >= (0 - (maxBorderWidth)))
            toX = 0 - (minWidth - _app.deviceInfo.deviceWidth - randomBorderWidth)
        else 
            toX = 0 - randomBorderWidth
        var toY = 0 - (Math.random() * (minHeight - _app.deviceInfo.deviceHeight))
        var speed = 60
        var duration = Math.abs(translationX - toX) * speed
        translateAnimation.toX = ((toX < 0) && (toX > (0 - minWidth))) ? toX : 0
        translateAnimation.toY = ((toY < 0) && (toY > (0 - minHeight))) ? toY : 0
        translateAnimation.duration = duration
        translateAnimation.play()
    }
}
