import bb.cascades 1.2
import "../CustomElements/constants.js" as Constants

Container {
    property bool minusButtonIncluded: false
    property bool plusButtonIncluded: false
    property bool playpauseButtonIncluded: false
    property bool powerButtonIncluded: false
    
    //property variant constants: Constants
    
    onMinusButtonIncludedChanged: { rewriteLabel() }
    onPlusButtonIncludedChanged: { rewriteLabel() }
    onPlaypauseButtonIncludedChanged: { rewriteLabel() }
    onPowerButtonIncludedChanged: { rewriteLabel() }
    
    visible: minusButtonIncluded || plusButtonIncluded || playpauseButtonIncluded || powerButtonIncluded

    layout: DockLayout {}
    horizontalAlignment: HorizontalAlignment.Fill
    topMargin: _ui.du(1)
    bottomMargin: topMargin
    
    function rewriteLabel() {
        var labelText = new String()
        var triggerName = new String()
        
        if (minusButtonIncluded) {
            labelText = qsTr("Volume DOWN") + Retranslate.onLocaleOrLanguageChanged
            triggerName = "minus"
        }
        
        if (plusButtonIncluded) {
            labelText += ((labelText != "") ? " & " : "") + qsTr("Volume UP") + Retranslate.onLocaleOrLanguageChanged
            triggerName += ((triggerName != "") ? "AndPlus" : "plus")
        }

        if (playpauseButtonIncluded) {
            labelText += ((labelText != "") ? " & " : "") + qsTr("Play") + Retranslate.onLocaleOrLanguageChanged
            triggerName += ((triggerName != "") ? "AndPlaypause" : "playpause")
        }
        
        if (powerButtonIncluded) {
            labelText += ((labelText != "") ? " & " : "") + qsTr("POWER") + Retranslate.onLocaleOrLanguageChanged
            triggerName += ((triggerName != "") ? "AndPower" : "power")
        }
        
        label.text = labelText.toString()
        buttonsParentContainer.triggerName = triggerName
    }
    
    Container {
        horizontalAlignment: HorizontalAlignment.Center
        background: Color.Black
        
        topPadding: _ui.du(1)
        bottomPadding: topPadding
        leftPadding: topPadding
        rightPadding: topPadding
        Container {
            horizontalAlignment: HorizontalAlignment.Center
            background: Color.White
            topPadding: _ui.du(1)
            bottomPadding: topPadding
            leftPadding: topPadding
            rightPadding: topPadding
            Label {
                id: label
                multiline: true
                textStyle.fontSize: FontSize.Large
                textStyle.fontWeight: FontWeight.Bold
                horizontalAlignment: HorizontalAlignment.Center
            }
            Container {
                id: buttonsParentContainer
                property string triggerName: ""
                
                layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
                TriggerContainer {
                    assignToTrigger: buttonsParentContainer.triggerName + "DoublePress"
                    buttonText: qsTr("Double Click") + Retranslate.onLocaleOrLanguageChanged
                }
                TriggerContainer {
                    assignToTrigger: buttonsParentContainer.triggerName + "LongPress"
                    buttonText: enabled ? (qsTr("Long Press") + Retranslate.onLocaleOrLanguageChanged) : "---"
                    enabled: !(plusButtonIncluded && minusButtonIncluded) && !powerButtonIncluded // We don't want to trigger a restart
                }
            }
        }
    }
}
