import bb.cascades 1.2

Container {
    id: dooTypeContainer
    
    property alias action: actionLabel.text
    property alias description: descriptionLabel.text
    property alias imageSource: imageView.imageSource
    property int dooType: -1
    
    signal clicked()
    
    topPadding: _ui.du(1)
    bottomPadding: topPadding
    leftPadding: topPadding
    rightPadding: topPadding
    
    topMargin: topPadding
    bottomMargin: topPadding
    leftMargin: topPadding
    rightMargin: topPadding

    layout: DockLayout {}
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Fill
    background: Color.Black
    
    gestureHandlers: [ TapHandler { onTapped: { dooTypeContainer.clicked() } }, DoubleTapHandler{ /* Do not allow double tap */ } ]

    Container {
        topPadding: _ui.du(1)
        bottomPadding: topPadding
        leftPadding: topPadding
        rightPadding: topPadding
        
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        background: Color.White

        Container {        
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            
            Label {
                id: actionLabel
                multiline: true
                textStyle.fontSize: FontSize.XLarge
                horizontalAlignment: HorizontalAlignment.Center
                visible: !imageView.visible
            }
            ImageView {
                id: imageView
                horizontalAlignment: HorizontalAlignment.Center
                scalingMethod: ScalingMethod.AspectFit
                minHeight: _ui.du(20)
                maxHeight: minHeight
                minWidth: minHeight
                maxWidth: minWidth
                visible: imageSource != ""
            }
            
            Label {
                id: descriptionLabel
                multiline: true
                textStyle.fontSize: FontSize.Medium
                textStyle.textAlign: TextAlign.Justify
                horizontalAlignment: HorizontalAlignment.Center
            }
        }
    }
}
