import bb.cascades 1.2
import bb.system 1.2

Container {
    id: hubAccountsContainer
    
    property alias action: actionLabel.text
    property alias description: descriptionLabel.text
    property string uri
    
    signal clicked()
    
    onClicked: {
        _assignment.assignCustomUri(hubAccountsSheet.assignToTrigger, uri, action, imageView.imageSource)
    }
        
    topPadding: _ui.du(1)
    bottomPadding: topPadding
    leftPadding: topPadding
    rightPadding: topPadding
    
    topMargin: topPadding
    bottomMargin: topPadding
    leftMargin: topPadding
    rightMargin: topPadding
    
    layout: DockLayout {}
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Fill
    background: Color.Black
    
    gestureHandlers: [ TapHandler { onTapped: { hubAccountsContainer.clicked() } }, DoubleTapHandler{ /* Do not allow double tap */ } ]

    Container {
        topPadding: _ui.du(1)
        bottomPadding: topPadding
        leftPadding: topPadding
        rightPadding: topPadding
        
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        background: Color.White

        Container {        
//            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            
            Container {
                layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
//                horizontalAlignment: HorizontalAlignment.Center
                ImageView {
                    id: imageView
                    imageSource: "asset:///Images/ic_hub.png"
                    verticalAlignment: VerticalAlignment.Center
                    scalingMethod: ScalingMethod.AspectFit
                    minHeight: actionLabelLuh.layoutFrame.height
                    minWidth: minHeight
                }
                Label {
                    id: actionLabel
                    multiline: true
                    textStyle.fontSize: FontSize.XLarge
                    verticalAlignment: VerticalAlignment.Center
                    attachedObjects: [ LayoutUpdateHandler { id: actionLabelLuh }]
                }
            }
            
            Label {
                id: descriptionLabel
                multiline: true
                textStyle.fontSize: FontSize.Medium
                textStyle.textAlign: TextAlign.Justify
//                horizontalAlignment: HorizontalAlignment.Center
                visible: text != ""
            }
        }
    }
}
