import bb.cascades 1.2
import bb.system 1.2

Container {
    id: settingsActionContainer
    
    property alias action: actionLabel.text
    property alias description: descriptionLabel.text
    property string iconFile
    property string uri
    
    signal clicked()
    
    onClicked: {
        _assignment.assignCustomUri(settingsActionsSheet.assignToTrigger, uri, action, ((iconFile != "") ? imageView.imageSource : ""))
    }
    
    topPadding: _ui.du(1)
    bottomPadding: topPadding
    leftPadding: topPadding
    rightPadding: topPadding
    
    topMargin: topPadding
    bottomMargin: topPadding
    leftMargin: topPadding
    rightMargin: topPadding
    
    layout: DockLayout {}
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Fill
    background: Color.Black
    
    gestureHandlers: [ TapHandler { onTapped: { settingsActionContainer.clicked() } }, DoubleTapHandler{ /* Do not allow double tap */ } ]

    Container {
        topPadding: _ui.du(1)
        bottomPadding: topPadding
        leftPadding: topPadding
        rightPadding: topPadding
        
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        background: Color.White

        Container {        
//            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            
            Container {
                layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
//                horizontalAlignment: HorizontalAlignment.Center
                ImageView {
                    id: imageView
                    imageSource: "file:///apps/" + _app.getSettingsPackageName() + "/public/icons/" + settingsActionContainer.iconFile
                    verticalAlignment: VerticalAlignment.Center
                    scalingMethod: ScalingMethod.AspectFit
                    minHeight: actionLabelLuh.layoutFrame.height
                    minWidth: minHeight
                    attachedObjects: [ 
                        LayoutUpdateHandler { 
                            id: imageViewLuh
                            onLayoutFrameChanged: {
                                // If imageView isn't visible, this setting is not accessible for that user
//                                settingsActionContainer.visible = (layoutFrame.height > 0)
                            }
                        }
                    ]
                }
                Label {
                    id: actionLabel
                    multiline: true
                    textStyle.fontSize: FontSize.XLarge
                    verticalAlignment: VerticalAlignment.Center
                    attachedObjects: [ LayoutUpdateHandler { id: actionLabelLuh }]
                }
            }
            
            Label {
                id: descriptionLabel
                multiline: true
                textStyle.fontSize: FontSize.Medium
                textStyle.textAlign: TextAlign.Justify
//                horizontalAlignment: HorizontalAlignment.Center
                visible: text != ""
            }
        }
    }
}
