import bb.cascades 1.2

Container {
    id: triggerContainer
//    layoutProperties: StackLayoutProperties { spaceQuota: 1 }
    property string assignToTrigger
    property alias buttonText: button.text
    property string labelText
    
    onLabelTextChanged: { label.text = labelText }

    layoutProperties: StackLayoutProperties { spaceQuota: 1 }

    background: Color.Black
    topPadding: _ui.du(0.5)
    bottomPadding: topPadding
    leftPadding: topPadding
    rightPadding: topPadding
    
    leftMargin: _ui.du(1)
    rightMargin: leftMargin
    
    Container {
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        background: Color.create(mainPage.constants.TERTIARY_COLOR)
        topPadding: _ui.du(1)
        bottomPadding: topPadding
        leftPadding: topPadding
        rightPadding: topPadding
        Container {
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            Button {
                id: button
                imageSource: (_settings.allSettings[triggerContainer.assignToTrigger] != undefined) ? _settings.allSettings[assignToTrigger].dooData.icon : ""
                horizontalAlignment: HorizontalAlignment.Center
                onClicked: {
                    var createdControl = dooTypeSelectionSheet.createObject(mainPage)
                    createdControl.assignToTrigger = triggerContainer.assignToTrigger
                    createdControl.open()
                }
            }
            Label {
                id: label
//                property variant dooNames: [qsTr("Open "), mainPage.constants.TRIGGER_CONTAINER_CALL_, mainPage.constants.TRIGGER_CONTAINER_COMPOSE_SMS_TO_, mainPage.constants.TRIGGER_CONTAINER_COMPOSE_EMAIL_TO_, mainPage.constants.TRIGGER_CONTAINER_COMPOSE_BBM_TO_, mainPage.constants.TRIGGER_CONTAINER_SEND_SMS_TO_, mainPage.constants.TRIGGER_CONTAINER_SEND_EMAIL_TO_, mainPage.constants.TRIGGER_CONTAINER_START_STOP_RECORDING_AUDIO, mainPage.constants.TRIGGER_CONTAINER_START_STOP_FLASHLIGHT, mainPage.constants.TRIGGER_CONTAINER_OPEN_, mainPage.constants.TRIGGER_CONTAINER_OPEN_]
                property variant dooNames: [""]
                property variant assignToTriggerInfos: _settings.allSettings[triggerContainer.assignToTrigger]
                
                onCreationCompleted: {
                    dooNames.push(qsTr("Open ") + Retranslate.onLanguageChanged)
                    dooNames.push(qsTr("Call ") + Retranslate.onLanguageChanged)
                    dooNames.push(qsTr("Compose SMS to ") + Retranslate.onLanguageChanged)
                    dooNames.push(qsTr("Compose email to ") + Retranslate.onLanguageChanged)
                    dooNames.push(qsTr("Compose BBM to ") + Retranslate.onLanguageChanged)
                    dooNames.push(qsTr("Send SMS to ") + Retranslate.onLanguageChanged)
                    dooNames.push(qsTr("Send email to ") + Retranslate.onLanguageChanged)
                    dooNames.push(qsTr("Start/Stop recording audio") + Retranslate.onLanguageChanged)
                    dooNames.push(qsTr("Start/Stop flashlight") + Retranslate.onLanguageChanged)
                    dooNames.push(qsTr("Open ") + Retranslate.onLanguageChanged)
                    dooNames.push(qsTr("Open ") + Retranslate.onLanguageChanged)
                }
                
                onAssignToTriggerInfosChanged: {
                    if (labelText != "")
                        return 
                    
                    if (assignToTriggerInfos == undefined) {
                        text = ""
                        return
                    }
                    
                    var dooType = _settings.allSettings[triggerContainer.assignToTrigger].dooType
                    text = dooNames[dooType]
                    
                    switch (dooType) {
                        case 0: {
                                var appName = _settings.allSettings[triggerContainer.assignToTrigger].dooData.appName
                                if (appName != undefined)
                                    text += appName
                                else 
                                    text = ""
                                break
                        }
                    case 1: 
                    case 2: 
                    case 3:
                    case 4:
                    case 5:
                    case 6: {
                            var contactName = _settings.allSettings[triggerContainer.assignToTrigger].dooData.contactName
                            if (contactName != undefined)
                                text += contactName
                            else 
                                text = ""
                            break
                    }
                case 7:
                case 8: {
                        break
                }
            case 9: {
                    var uriName = _settings.allSettings[triggerContainer.assignToTrigger].dooData.uriName
                    if (uriName != undefined)
                        text = uriName
                    else 
                        text = ""
                    break
            }
            case 10: {
                    var uri = _settings.allSettings[triggerContainer.assignToTrigger].dooData.invokeData.uri
                    uri = uri.replace("bbfiles:///accounts/1000/shared", "")
                    uri = uri.replace("bbfiles:///accounts/1000-enterprise/shared", "")
                    if (uri != undefined) {
                        text += uri
                    }
                    else 
                        text = ""
                    break
            }
        default:
            break
                    }
                }
                
                multiline: true
                horizontalAlignment: HorizontalAlignment.Center
                visible: (text != "")
                content.flags: TextContentFlag.Emoticons
            }
        }
    }
}
