import bb.cascades 1.2
import bb.device 1.2

Container {
    id: whatToDooCardTemplateContainer
    
    property variant parentLuh
    property alias imageSource: imageView.imageSource
    property alias whatToDoo: whatToDooLabel.text
    property alias description: descriptionLabel.text
    property bool isFocused: false
    
    property int centerX: luh.layoutFrame.x + (luh.layoutFrame.width / 2) + parentLuh.layoutFrame.x
    property int deviceWidth: _app.deviceInfo.deviceWidth
    property int deviceHeight: _app.deviceInfo.deviceHeight
    
    property string assignToTrigger
    
    signal clicked()
    
    attachedObjects: [ 
        HardwareInfo { id: hardwareInfo },
        LayoutUpdateHandler { id: luh }
    ]
    
    rotationZ: (centerX - (deviceWidth / 2)) * 35 / (deviceWidth / 2)
    
    topPadding: _ui.du(1)
    bottomPadding: topPadding
    leftPadding: topPadding
    rightPadding: topPadding
    
    leftMargin: deviceWidth * 0.15
    rightMargin: leftMargin
    
    maxWidth: deviceWidth * ((hardwareInfo.modelName.indexOf("Z10") >= 0) ? 0.40 : 0.35)
    minWidth: maxWidth
    
    maxHeight: deviceHeight * 0.75
    minHeight: maxHeight
    
    layout: DockLayout {}
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Center
    background: Color.Black
    
    opacity: isFocused ? 1 : 0.3

//    gestureHandlers: [ TapHandler { onTapped: { if (isFocused) whatToDooCardTemplateContainer.clicked() } }, DoubleTapHandler{ /* Do not allow double tap */ } ]
        
    Container {
        id: innerContainer
        topPadding: deviceHeight * 0.01
        bottomPadding: topPadding
        leftPadding: deviceWidth * 0.01
        rightPadding: leftPadding
        
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        background: isFocused ? Color.create(mainPage.constants.SECONDARY_COLOR) : Color.LightGray
//        background: Color.create(mainPage.constants.SECONDARY_COLOR)
        
        Container {        
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            
            ImageView {
                id: imageView
                imageSource: "asset:///Images/doo_neon.png"
                horizontalAlignment: HorizontalAlignment.Center
                scalingMethod: ScalingMethod.AspectFit
            }
            Label {
                id: whatToDooLabel
                multiline: true
                textStyle.fontSize: FontSize.PointValue
                textStyle.fontSizeValue: _ui.du(1) - 1
                textStyle.textAlign: TextAlign.Center
                horizontalAlignment: HorizontalAlignment.Center
            }
            Label {
                id: descriptionLabel
                visible: false
                multiline: true
                textStyle.fontSize: FontSize.Medium
                textStyle.textAlign: TextAlign.Justify
                horizontalAlignment: HorizontalAlignment.Center
            }
        }
    }
}
