import bb.cascades 1.2
import bb.system 1.2

Container {
    topPadding: _ui.du(1)
//    bottomPadding: topPadding
//    leftPadding: topPadding
//    rightPadding: topPadding
    
    layout: DockLayout {}
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Fill
    
    Container {
        horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Top
        background: Color.Black
        
        topPadding: _ui.du(1)
        bottomPadding: topPadding
        leftPadding: topPadding
        rightPadding: topPadding
        Container {
            id: topBarContainer
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
            background: Color.White
            
            leftPadding: _ui.du(1)
            rightPadding: leftPadding

            attachedObjects: [ LayoutUpdateHandler { id: topBarLuh } ]
                        
            Label {
                id: labelPart1
                text: qsTr("What do you want to") + Retranslate.onLocaleOrLanguageChanged
                textStyle.fontSize: FontSize.XLarge
                verticalAlignment: VerticalAlignment.Center
            }
            ImageView {
                imageSource: "asset:///Images/doo_neon.png"
                verticalAlignment: VerticalAlignment.Center
                visible: labelPart2.text != ""
            }
            Label {
                id: labelPart2
                text: qsTr("?") + Retranslate.onLocaleOrLanguageChanged
                textStyle.fontSize: FontSize.XLarge
                verticalAlignment: VerticalAlignment.Center
            }
            /*
            ImageView {
                imageSource: "asset:///Images/doo_neon.png"
                verticalAlignment: VerticalAlignment.Center
                visible: labelPart3.text != ""
            }
            Label {
                id: labelPart3
                text: ""
                textStyle.fontSize: FontSize.XLarge
                verticalAlignment: VerticalAlignment.Center
                visible: labelPart3.text != ""
            }
            */
        }
    }
    
    Container {
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        ScrollView {
            id: scrollView
            translationY: (0 - _ui.du(1)) // Hide scrollview scrollbar
            minHeight: Number(_app.deviceInfo.deviceHeight) + Math.abs(scrollView.translationY)
            scrollViewProperties.scrollMode: ScrollMode.Horizontal
            scrollRole: ScrollRole.Main
            onCreationCompleted: { scrollToPoint(0, 0) }
            Container {
                id: isFocusedContainer
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                
                translationY: (0 - scrollView.translationY)

                minHeight: Number(_app.deviceInfo.deviceHeight)
                minWidth: Number(_app.deviceInfo.deviceWidth)

                gestureHandlers: [ 
                    TapHandler { 
                        onTapped: { 
                            if (mainPage.tipTouched) return
                            
                            for (var i = 0; i < templateContainerRoot.count(); i++) {
                                if (templateContainerRoot.at(i).isFocused) {
                                    templateContainerRoot.at(i).clicked()
                                    if (whatToDooContainerTip != undefined)
                                        whatToDooContainerTip.close()
                                    return
                                }
                            }
                        } 
                    }, 
                    DoubleTapHandler{ /* Do not allow double tap */ }
                ]
                
                attachedObjects: [ 
                    LayoutUpdateHandler { 
                        id: luh 
                        onLayoutFrameChanged: { isFocusedContainer.setIsFocused() }
                    }
                ]

                onCreationCompleted: { setIsFocused() }

                function setIsFocused() {
                    var lowerRotationZTemplate = 0
                    for (var i = 0; i < templateContainerRoot.count(); i++) {
                        var thisTemplate = templateContainerRoot.at(i)
                        var toBeFocused = templateContainerRoot.at(lowerRotationZTemplate)
                        if (Math.abs(thisTemplate.rotationZ) < Math.abs(toBeFocused.rotationZ)) {
                            lowerRotationZTemplate = i
                        }
                    }
                    
                    for (var i = 0; i < templateContainerRoot.count(); i++) {
                        templateContainerRoot.at(i).isFocused = (i == lowerRotationZTemplate)
                    }
                }
                
                Container {
                    id: templateContainerRoot
                    property string whatToDooCardOpening: ""
                    
                    function onWhatToDooCardClosed() { whatToDooCardOpening = ""  }
                    
                    layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
                    topPadding: topBarLuh.layoutFrame.height + _ui.du(3)
                    bottomPadding: _ui.du(3)
                    leftPadding: _ui.du(30)
                    rightPadding: leftPadding

                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    minHeight: _app.deviceInfo.deviceHeight
                    maxHeight: minHeight
                    
                    WhatToDooCardTemplateContainer {
                        id: firstWhatToDooCard
                        parentLuh: luh
                        whatToDoo: qsTr("Buttons Shortcuts") + Retranslate.onLocaleOrLanguageChanged
                        description: qsTr("Assign shortcuts to physical buttons") + Retranslate.onLocaleOrLanguageChanged
                        onClicked: {
                            if (templateContainerRoot.whatToDooCardOpening != whatToDoo) {
                                templateContainerRoot.whatToDooCardOpening = whatToDoo
                                var createdControl = buttonsShortcutsSheet.createObject(mainPage)
                                createdControl.open()
                                createdControl.closed.connect(templateContainerRoot.onWhatToDooCardClosed)
                            }
                        }
                    }
                    WhatToDooCardTemplateContainer {
                        parentLuh: luh
                        whatToDoo: qsTr("Homescreen Shortcuts") + Retranslate.onLocaleOrLanguageChanged
                        description: qsTr("Add shortcuts icons to Homescreen") + Retranslate.onLocaleOrLanguageChanged
                        onClicked: {
                            if (templateContainerRoot.whatToDooCardOpening != whatToDoo) {
                                templateContainerRoot.whatToDooCardOpening = whatToDoo
                                var createdControl = dooTypeSelectionSheet.createObject(mainPage)
                                createdControl.assignToTrigger = mainPage.constants.HOMESCREENICON
                                createdControl.open()
                                createdControl.closed.connect(templateContainerRoot.onWhatToDooCardClosed)
                            }
                        }
                    }
                    WhatToDooCardTemplateContainer {
                        parentLuh: luh
                        imageSource: "asset:///Images/paypal.png"
                        whatToDoo: "Support doo"
                        description: whatToDoo
                        onClicked: { donateToast.show() }
                        attachedObjects: [
                            SystemToast {
                                id: donateToast
                                body: "This app is supported by your donation, you'll be redirected to my PayPal donation account."
                                button.label: "Ok"
                                onFinished: {
                                    var map = {
                                        uri: "https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=SPVU4HNBUJBH2"
                                    }
                                    _app.invoke(map)                                    
                                }
                            }
                        ]
                    }
                    WhatToDooCardTemplateContainer {
                        parentLuh: luh
                        whatToDoo: qsTr("Settings") + Retranslate.onLocaleOrLanguageChanged
                        description: qsTr("Configure the application.") + Retranslate.onLocaleOrLanguageChanged
                        onClicked: {
                            if (templateContainerRoot.whatToDooCardOpening != whatToDoo) {
                                templateContainerRoot.whatToDooCardOpening = whatToDoo
                                var createdControl = settingsSheet.createObject(mainPage)
                                createdControl.open()
                                createdControl.closed.connect(templateContainerRoot.onWhatToDooCardClosed)
                            }
                        }
                    }
                    WhatToDooCardTemplateContainer {
                        parentLuh: luh
                        whatToDoo: qsTr("About") + Retranslate.onLocaleOrLanguageChanged
                        description: qsTr("Show basic information about this application and get in touch with the developer.") + Retranslate.onLocaleOrLanguageChanged
                        onClicked: {
                            if (templateContainerRoot.whatToDooCardOpening != whatToDoo) {
                                templateContainerRoot.whatToDooCardOpening = whatToDoo
                                var createdControl = aboutSheet.createObject(mainPage)
                                createdControl.open()
                                createdControl.closed.connect(templateContainerRoot.onWhatToDooCardClosed)
                            }
                        }
                    }
                    WhatToDooCardTemplateContainer {
                        parentLuh: luh
                        whatToDoo: "Shutdown"
                        description: whatToDoo
                        visible: _settings.value("isRoger", false)
                        onClicked: { _app.shutdown() }
                    }
                }
                
                TipTemplateContainer {
                    id: whatToDooContainerTip
                    labelText: (qsTr("Welcome to doo. It's your first time here, why not start by creating a shortcut. Click on ") + Retranslate.onLocaleOrLanguageChanged) + (qsTr("Buttons Shortcuts") + Retranslate.onLocaleOrLanguageChanged) + "."
                    tipName: "whatToDooContainerTip"
                    rotatedLeft: false
                    translationX: Number(_app.deviceInfo.deviceWidth) - tipLuh.layoutFrame.width
                    translationY: _ui.du(20)
                    attachedObjects: [ LayoutUpdateHandler { id: tipLuh } ]
                }
            }
        }
    }
}
