import bb.cascades 1.2
import bb.device 1.2
import "../CustomElements"

Container {
    attachedObjects: [ HardwareInfo { id: hardwareInfo } ]
    visible: hardwareInfo.isPhysicalKeyboardDevice
    topMargin: _ui.du(2)
    bottomMargin: topMargin
    
    topPadding: _ui.du(1)
    bottomPadding: topPadding
    leftPadding: topPadding
    rightPadding: topPadding
    
    background: Color.Black
    Container {
        topPadding: _ui.du(1)
        bottomPadding: topPadding
        leftPadding: topPadding
        rightPadding: topPadding
        
        background: Color.White
        Container {
            Container {
                layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
                horizontalAlignment: HorizontalAlignment.Center
                Label {
                    text: qsTr("Clear Clipboard Button") + Retranslate.onLocaleOrLanguageChanged
                    multiline: true
                    textStyle.textAlign: TextAlign.Center
                    textStyle.fontSize: FontSize.XLarge
                    verticalAlignment: VerticalAlignment.Center
                }
                ToggleButton {
                    verticalAlignment: VerticalAlignment.Center
                    checked: _settings.value("clearClipboardEnabled", true)
                    onCheckedChanged: _settings.setValue("clearClipboardEnabled", checked)
                }
            }
            Label {
                text: qsTr("Decide if you want to include a 'Clear Clipboard' button in the Clipboard trigger dialog.") + Retranslate.onLocaleOrLanguageChanged
                textStyle.fontSize: FontSize.Small
                textStyle.textAlign: TextAlign.Justify
                multiline: true
            }
        }
    }
}
