import bb.cascades 1.2
import bb.cascades.places 1.0
import "../CustomElements"

Container {
    layout: DockLayout {}
    horizontalAlignment: HorizontalAlignment.Fill

    topMargin: _ui.du(2)
    bottomMargin: topMargin
    
    topPadding: _ui.du(1)
    bottomPadding: topPadding
    leftPadding: topPadding
    rightPadding: topPadding
            
    background: Color.Black
    Container {
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill

        topPadding: _ui.du(1)
        bottomPadding: topPadding
        leftPadding: topPadding
        rightPadding: topPadding
        
        background: Color.White
        Container {
            horizontalAlignment: HorizontalAlignment.Center
            Label {
                text: qsTr("Language") + Retranslate.onLocaleOrLanguageChanged
                multiline: true
                textStyle.textAlign: TextAlign.Center
                textStyle.fontSize: FontSize.XLarge
                horizontalAlignment: HorizontalAlignment.Center
            }
            
            DropDown {
                id: languageDropDown
                title: qsTr("Language") + Retranslate.onLanguageChanged
                horizontalAlignment: HorizontalAlignment.Center
                Option {                        
                    text: "Default"
                    value: "default"
                }
                Option {                        
                    text: "Dutch"
                    value: "nl"
                }
                Option {                        
                    text: "English"
                    value: "en"
                }
                Option {                        
                    text: "French"
                    value: "fr"
                }
                Option {                        
                    text: "German"
                    value: "de"
                }
                Option {                        
                    text: "Hindi"
                    value: "hi"
                }
                Option {                        
                    text: "Vietnamese"
                    value: "vi"
                }
                
                /*
                Option {                        
                    text: "Chinese"
                    value: "zh"
                }
                Option {                        
                    text: "Czech"
                    value: "cs"
                }
                Option {                        
                    text: "German"
                    value: "de"
                }
                Option {                        
                    text: "Indonesian"
                    value: "in"
                }
                Option {                        
                    text: "Italian"
                    value: "it"
                }
                Option {                        
                    text: "Persian"
                    value: "fa"
                }
                Option {                        
                    text: "Russian"
                    value: "ru"
                }
                Option {                        
                    text: "Spanish"
                    value: "es"
                }
                Option {                        
                    text: "Ukrainian"
                    value: "uk"
                }
                */
                onSelectedOptionChanged: { 
                    _settings.setValue("language", selectedValue) 
                    _app.onSystemLanguageChanged()
                    _headlessCommunication.sendMessage("LANGUAGE_CHANGED", selectedValue)
                }
                onCreationCompleted: {
                    var settingsValue = _settings.value("language", "default")
                    for (var i = 0; i < languageDropDown.count(); i++) {
                        if (settingsValue == languageDropDown.at(i).value)
                            languageDropDown.setSelectedOption(languageDropDown.at(i))
                    }
                }
            }
        }
    }
}
