import bb.cascades 1.2
import bb.system 1.2
import "../MyApps"
import "../CustomElements"

Sheet {
    id: aboutSheet
    
    onOpened: { myApps.autoScroll = true; }
    onClosed: { myApps.autoScroll = false; }

    peekEnabled: false

    Page {
        titleBar: TitleBar {
            title: qsTr("About") + Retranslate.onLocaleOrLanguageChanged
            acceptAction: ActionItem {
                title: qsTr("OK") + Retranslate.onLocaleOrLanguageChanged
                onTriggered: { aboutSheet.close() }
            }
        }
        
        ScrollView {
            scrollRole: ScrollRole.Main
            Container {
                id: mainContainer
                
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                leftPadding: _ui.du(3)
                rightPadding: leftPadding
                topPadding: _ui.du(1)
                bottomPadding: topPadding
                Container {
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    Container {
                        horizontalAlignment: HorizontalAlignment.Center
                        Container {
                            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
                            horizontalAlignment: HorizontalAlignment.Center
                            ImageView {
                                imageSource: "asset:///Images/icon.png"
                                scalingMethod: ScalingMethod.AspectFill
                                verticalAlignment: VerticalAlignment.Center
                            }
                            Label {
                                id: appNameLabel
                                verticalAlignment: VerticalAlignment.Center
                                text: Application.applicationVersion
                                textStyle.base: SystemDefaults.TextStyles.BigText
                            }
                        }
                        Container {
                            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
                            horizontalAlignment: HorizontalAlignment.Center
                            gestureHandlers: [ TapHandler { onTapped: { _app.sendLog() } } ]
                            Label {
                                text: qsTr("by CellNinja") + Retranslate.onLanguageChanged
                                multiline: true
                                textStyle.base: SystemDefaults.TextStyles.TitleText
                                textStyle.color: Color.Blue
                                verticalAlignment: VerticalAlignment.Center
                                attachedObjects: [ LayoutUpdateHandler { id: labelLuh } ]
                            }
                            ImageView {
                                imageSource: "asset:///Images/ic_email.png"
                                maxHeight: labelLuh.layoutFrame.height * 2
                                minHeight: maxHeight
                                maxWidth: maxHeight
                                minWidth: maxWidth
                                scalingMethod: ScalingMethod.AspectFit
                                verticalAlignment: VerticalAlignment.Center
                            }
                        }
                    }
                    MyApps { id: myApps; topPadding: _ui.du(5) }
                    Container {
                        topPadding: _ui.du(3)
                        horizontalAlignment: HorizontalAlignment.Center
                        Header { title: qsTr("Social") + Retranslate.onLocaleOrLanguageChanged }
                        Label {}
                        Button {
                            text: qsTr("CellNinja BBM Channel") + Retranslate.onLanguageChanged
                            imageSource: "asset:///Images/ic_bbmchannel.png"
                            horizontalAlignment: HorizontalAlignment.Center
                            onClicked: { 
                                invokeChannel.query.invokeTargetId = "sys.bbm.channels.card.previewer"
                                invokeChannel.query.invokeActionId = "bb.action.OPENBBMCHANNEL"
                                invokeChannel.query.uri = "bbmc:C004E866D"
                                invokeChannel.query.updateQuery()
                            }
                            attachedObjects: [
                                Invocation {
                                    id: invokeChannel
                                    onArmed: { trigger(query.invokeActionId) }
                                }
                            ]
                        }
                    }
                }
                
                TipTemplateContainer {
                    id: aboutSheetTip
                    labelText: qsTr("Having an issue with the app? Easily contact us by clicking on 'CellNinja' just below the app name.") + Retranslate.onLocaleOrLanguageChanged
                    tipName: "aboutSheetTip"
                    rotatedLeft: true
                    translationX: _ui.du(10)
                    translationY: Number(_app.deviceInfo.deviceHeight) - tipLuh.layoutFrame.height - _ui.du(20)
                    attachedObjects: [ LayoutUpdateHandler { id: tipLuh } ]
                }
            }
        }
    }
}