import bb.cascades 1.2
import "../CustomElements"

Sheet {
    id: buttonsShortcutsSheet

    onOpened: { _assignment.assigned.connect(onAssigned) }    
    onClosed: { destroy() }

    function onAssigned(map) {
        buttonsShortcutsSheetFirstShortcutAssignedTip.labelText = qsTr("Congratulations, now try double clicking or long pressing that button. Tutorial is over, don't forget to contact us through About page if you have any issue with doo.") + Retranslate.onLocaleOrLanguageChanged
    }
    
    peekEnabled: false
    
    Page {
        titleBar: TitleBar {
            title: qsTr("Buttons Shortcuts") + Retranslate.onLocaleOrLanguageChanged
            acceptAction: ActionItem {
                title: qsTr("OK") + Retranslate.onLocaleOrLanguageChanged
                onTriggered: { buttonsShortcutsSheet.close() }
            }
        }

        Container {
            minHeight: _app.deviceInfo.deviceHeight
            minWidth: _app.deviceInfo.deviceWidth

            layout: DockLayout {}
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            
            AnimatedBackground {}
            
            ScrollView {
                minWidth: _app.deviceInfo.deviceWidth
                
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center

                scrollRole: ScrollRole.Main

                Container {
                    layout: DockLayout {}
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                    
                    minWidth: _app.deviceInfo.deviceWidth
                    
                    attachedObjects: [ LayoutUpdateHandler { id: luh } ]
                    
                    Container {
                        topPadding: _ui.du(3)
                        bottomPadding: topPadding
                        leftPadding: topPadding
                        rightPadding: topPadding
                        
                        horizontalAlignment: HorizontalAlignment.Center
                        verticalAlignment: VerticalAlignment.Center
                        
                        ButtonsIncludedTemplate {
                            plusButtonIncluded: true
                            playpauseButtonIncluded: false
                            minusButtonIncluded: false
                            powerButtonIncluded: false
                        }
                        ButtonsIncludedTemplate {
                            plusButtonIncluded: false
                            playpauseButtonIncluded: true
                            minusButtonIncluded: false
                            powerButtonIncluded: false
                        }
                        ButtonsIncludedTemplate {
                            plusButtonIncluded: false
                            playpauseButtonIncluded: false
                            minusButtonIncluded: true
                            powerButtonIncluded: false
                        }
                        ButtonsIncludedTemplate {
                            plusButtonIncluded: true
                            playpauseButtonIncluded: true
                            minusButtonIncluded: false
                            powerButtonIncluded: false
                        }
                        ButtonsIncludedTemplate {
                            plusButtonIncluded: false
                            playpauseButtonIncluded: true
                            minusButtonIncluded: true
                            powerButtonIncluded: false
                        }
                        ButtonsIncludedTemplate {
                            plusButtonIncluded: true
                            playpauseButtonIncluded: true
                            minusButtonIncluded: true
                            powerButtonIncluded: false
                        }
                        ButtonsIncludedTemplate {
                            plusButtonIncluded: false
                            playpauseButtonIncluded: false
                            minusButtonIncluded: false
                            powerButtonIncluded: true
                        }
                    }
                }
            }
            
            TipTemplateContainer {
                id: buttonsShortcutsSheetTip
                labelText: qsTr("Each button combination allows two types of click : Double Click or Long Press. Locate Play button in the list and click on Long Press.") + Retranslate.onLocaleOrLanguageChanged
                tipName: "buttonsShortcutsSheetTip"
                rotatedLeft: true
                translationX: _ui.du(10)
                translationY: Number(_app.deviceInfo.deviceHeight) - tipLuh.layoutFrame.height - _ui.du(20)
                attachedObjects: [ LayoutUpdateHandler { id: tipLuh } ]
            }
            
            TipTemplateContainer {
                id: buttonsShortcutsSheetFirstShortcutAssignedTip
                tipName: "buttonsShortcutsSheetFirstShortcutAssignedTip"
                rotatedLeft: false
                translationX: (Number(_app.deviceInfo.deviceWidth) / 2) - (tipLuh2.layoutFrame.width / 2)
                translationY: (Number(_app.deviceInfo.deviceHeight) / 2) - (tipLuh2.layoutFrame.height / 2)
                attachedObjects: [ LayoutUpdateHandler { id: tipLuh2 } ]
            }
        }
    }
}