import bb.cascades 1.2
import bb.system 1.2
import "../CustomElements"

Sheet {
    id: hubAccountsSheet
    
    property string assignToTrigger

    onOpened: { 
        _assignment.assigned.connect(onAssigned)
    }    
    
    onClosed: { destroy() }
    
    function onAssigned(map) { close() }
    
    peekEnabled: false
    
    Page {
        titleBar: TitleBar {
            title: qsTr("Hub Accounts") + Retranslate.onLocaleOrLanguageChanged
            dismissAction: ActionItem {
                title: qsTr("Cancel") + Retranslate.onLocaleOrLanguageChanged
                onTriggered: { hubAccountsSheet.close() }
            }
        }
        
        Container {
            id: hubAccountsMainContainer
            layout: DockLayout {}
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            
            attachedObjects: [ LayoutUpdateHandler { id: hubAccountsMainContainerLuh }]
            
            AnimatedBackground {}
            ScrollView {
                id: scrollView
                scrollRole: ScrollRole.Main
                Container {
                    id: hubAccountsContainer
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    topPadding: _ui.du(3)
                    bottomPadding: topPadding
                    leftPadding: topPadding
                    rightPadding: topPadding
                    
                    minWidth: hubAccountsMainContainerLuh.layoutFrame.width
                    
                    onCreationCompleted: {
                        var hubAccounts = _app.accounts
                        for(var i = 0; i < hubAccounts.length; i++) {
                            var createdControl = hubAccountTemplateComponent.createObject(hubAccountsContainer)
                            createdControl.action = hubAccounts[i].displayName
                            createdControl.uri = "pim:application/vnd.blackberry.hub:" + hubAccounts[i].id
                            hubAccountsContainer.add(createdControl)
                        }
                    }
                    
                    attachedObjects: [
                        ComponentDefinition {
                            id: hubAccountTemplateComponent
                            HubAccountTemplate { id: hubAccountTemplate }
                        }
                    ]
                }
            }
        }
    }
}