import bb.cascades 1.2
import bb.system 1.2
import "../CustomElements"

Sheet {
    id: settingsActionsSheet
    
    property string assignToTrigger

    onOpened: { 
        _assignment.assigned.connect(onAssigned)
    }    
    
    onClosed: { destroy() }
    
    function onAssigned(map) { close() }
    
    peekEnabled: false
    
    Page {
        titleBar: TitleBar {
            title: qsTr("Settings Shortcuts") + Retranslate.onLocaleOrLanguageChanged
            dismissAction: ActionItem {
                title: qsTr("Cancel") + Retranslate.onLocaleOrLanguageChanged
                onTriggered: { settingsActionsSheet.close() }
            }
        }
        
        Container {
            id: settingsActionsMainContainer
            layout: DockLayout {}
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            
            attachedObjects: [ LayoutUpdateHandler { id: settingsActionsMainContainerLuh }]
            
            AnimatedBackground {}
            ScrollView {
                id: scrollView
                scrollRole: ScrollRole.Main
                Container {
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    topPadding: _ui.du(3)
                    bottomPadding: topPadding
                    leftPadding: topPadding
                    rightPadding: topPadding
                    
                    minWidth: settingsActionsMainContainerLuh.layoutFrame.width
                    
                    SettingsActionTemplate {
                        action: qsTr("Mobile Network") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_mobile_network.png"
                        uri: "settings://radio"
                    }

                    SettingsActionTemplate {
                        action: qsTr("Wi-Fi") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_wifi.png"
                        uri: "settings://wifi"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("Bluetooth") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_ub_bluetooth.png"
                        uri: "settings://bluetooth"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("VPN") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_vpn.png"
                        uri: "settings://vpn"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("NFC") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_nfc.png"
                        uri: "settings://nfc"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("Location Services") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_location.png"
                        uri: "settings://location"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("Accounts") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_accounts.png"
                        uri: "settings://pim"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("Notifications") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_notification.png"
                        uri: "settings://notification"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("Display") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_display.png"
                        uri: "settings://display"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("Data Management") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_data_management.png"
                        uri: "devicemonitor://datamanagement/"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("Shortcuts and Speed Dial") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_tips_shortcuts.png"
                        uri: "settings://shortcuts"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("Development Mode") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_development_mode.png"
                        uri: "settings://devmode"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("App Manager") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_app_manager.png"
                        uri: "settings://appmgr"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("Battery Saving Mode") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_powersave.png"
                        uri: "settings://powersaving"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("Language and Input") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_language_input.png"
                        uri: "settings://language"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("Application Permissions") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_permissions.png"
                        uri: "settings://permissions"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("Storage and Access") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_storage_access.png"
                        uri: "settings://storage"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("About") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_about.png"
                        uri: "settings://about"
                    }
                    
                    SettingsActionTemplate {
                        action: qsTr("About Network") + Retranslate.onLocaleOrLanguageChanged
                        iconFile: "ca_about.png"
                        uri: "settings://about/network"
                    }
                    
                    /*
                     * file:///apps/sys.settings.gYABgFXZghhSmuJ6oBTACT1DwpQ/public/icons/...
                     
                     Software Release
                     settings://about/general
                     asset:///settings/about/About.qml?category=General.qml
                     
                     Hardware Storage
                     settings://about/hardware
                     asset:///settings/about/About.qml?category=Hardware.qml
                     
                     OS Version
                     settings://about/os
                     asset:///settings/about/About.qml?category=OS.qml
                     
                     About Network
                     settings://about/network
                     asset:///settings/about/About.qml?category=Network.qml
                     
                     Legal
                     settings://about/legal
                     asset:///settings/about/About.qml?category=Legal.qml
                     
                     Work Space
                     asset:///settings/about/About.qml?category=BlackBerryBalance.qml
                     
                     Network Connections
                     settings://networkconnections
                     asset:///settings/networkconnections/NetworkConnectionsPage.qml
                     icons/ca_connections.png
                     
                     
                     
                     Automatic VPN Connections
                     settings://vpn/autoConnect
                     asset:///settings/vpn/VpnAutoConnectPage.qml
                                          
                     Contacts Notifications
                     settings://notification/contact
                     asset:///settings/notifications/ContactPage.qml
                     
                     Contacts Notifications Settings
                     settings://notification/contact_settings
                     asset:///settings/notifications/ContactSettingPage.qml
                     
                     Contacts Notifications Editor
                     settings://notification/contact_editor
                     
                     Level 1 Notifications
                     settings://notification/level1
                     asset:///settings/notifications/CategoryPage.qml?type=level1
                     
                     Application Notifications
                     settings://notification/application
                     asset:///settings/notifications/ProfileAppSettingsPage.qml
                     
                     Profile Editor
                     settings://notification/profiles
                     asset:///settings/notifications/ProfileEditorPage.qml
                     
                     Favorite Notification Profiles
                     settings://notification/favorite_profiles
                     asset:///settings/notifications/FavoriteProfileList.qml
                     
                     Device Connections
                     settings://link
                     asset:///settings/bblink/BlackBerryLink.qml
                     icons/ca_bblink.png
                     
                     System Volume
                     settings://sound
                     asset:///settings/sound/SystemVolumePage.qml
                     icons/ca_system_volume.png
                                          
                     Add Account
                     settings://pim/createAccount
                     accounts://pim/createAccount
                     
                     Default Accounts
                     settings://pim/defaultAccounts
                     accounts://pim/defaultAccountsnone
                     
                     /-
                     settings://pim/showAccount
                     accounts://pim/showAccount
                     
                     settings://pim/listAccounts
                     accounts://pim/listAccounts
                     -/
                
                    Create Account
                    settings://pim/createAccountType
                    accounts://pim/createAccountType
                
                    /-
                     settings://pim/deleteAccount
                     accounts://pim/deleteAccount
                     
                     settings://pim/EnrollmentProgress
                     accounts://pim/EnrollmentProgress
                     -/
                
                                              
                                              Advanced Display
                                              settings://display/advanced
                                              asset:///settings/display/AdvancedPage.qml
                                              
                                              Input Languages
                                              settings://language/input
                                              asset:///settings/input/InputLanguages.qml
                                              
                                              On-Screen Keyboard
                                              settings://language/keyboard
                                              asset:///settings/input/Feedback.qml
                                              
                                              Spell Check
                                              settings://language/spellcheck
                                              asset:///settings/input/SpellCheck.qml
                                              
                                              Prediction and Correction
                                              settings://language/assistance
                                              asset:///settings/input/PredictionCorrection.qml
                                              
                                              Voice Dictation
                                              settings://language/voicedictation
                                              asset:///settings/voice/VoiceDictation.qml
                                              
                                              BlackBerry Assistant
                                              asset:///settings/voice/VoiceControl.qml
                                              icons/ca_microphone.png
                                              
                                              BlackBerry Balance
                                              asset:///settings/balance/BlackBerryBalancePage.qml
                                              icons/ca_balance.png
                                              
                                              BlackBerry ID
                                              settings://bbid
                                              asset:///settings/bbid/BlackBerryID.qml
                                              icons/ca_bbid.png
                                              
                                              BlackBerry ID Information
                                              settings://bbid/landing
                                              
                                              BBID Password
                                              settings://bbid/password
                                              
                                              Password Recovery
                                              settings://bbid/recovery
                                              
                                              BlackBerry Protect
                                              settings://protect
                                              asset:///settings/protect/BlackBerryProtect.qml
                                              icons/ca_protect.png
                                              
                                              Security and Privacy
                                              settings://security
                                              asset:///settings/security/SecurityAndPrivacyPage.qml
                                              icons/ca_lock.png
                                              
                                              SIM Card
                                              settings://sim
                                              asset:///settings/security/SIMCardPage.qml
                                              icons/ca_sim_card.png
                                              
                                              Diagnostics
                                              settings://diagnostics
                                              asset:///settings/security/DiagnosticsPage.qml
                                              icons/ca_diagnostics.png
                                              
                                              Device Password
                                              settings://password
                                              asset:///settings/security/DevicePasswordPage.qml
                                              icons/ca_passwords.png
                                              
                                              Security Wipe
                                              settings://wipe
                                              asset:///settings/security/SecurityWipePage.qml
                                              icons/ca_security_wipe.png
                                              
                                              Certificates
                                              settings://certificates
                                              asset:///settings/certificates/CertificatesPage.qml
                                              icons/ca_certificates.png
                                              
                                              Lock Screen
                                              settings://lockscreen
                                              asset:///settings/security/LockScreen.qml
                                              icons/ca_lock_screen.png
                                              
                                              Import Certificate
                                              settings://certificate/import
                                              asset:///settings/certificates/CertificateDetails.qml
                                              
                                              Certificate Details
                                              settings://certificate/detailsSSL/TLS
                                              settings://ssl_tls
                                              asset:///settings/security/SslTlsPage.qml
                                              
                                              Media Sharing
                                              settings://sharing
                                              asset:///settings/sharing/MediaSharingPage.qml
                                              icons/ca_sharing_files.png
                                              
                                              Date and Time
                                              settings://datetime
                                              asset:///settings/datetime/DateAndTimePage.qml
                                              icons/ca_date_time.png
                                              
                                              Software Updates
                                              settings://softwareupdate
                                              asset:///settings/softwareupdate/SoftwareUpdate.qml
                                              icons/ca_software_updates.png
                                              
                                              Payment Options
                                              settings://payment
                                              payment://paymentoptions
                                              icons/ca_payment_options.png
                                              
                                              Accessibility
                                              settings://accessibility
                                              asset:///settings/accessibility/AccessibilityPage.qml
                                              icons/ca_accessibility.png
                                              
                                              Screen Reader
                                              settings://screenreader
                                              asset:///settings/accessibility/ScreenReader.qml
                                              
                                              ????
                                              settings://wifi/connected
                                              
                                              USB Standard Speed
                                              asset:///settings/usb/UsbSpeed.qml
                                              ????
                                              
                                              Card Emulation Apps
                                              settings://cardemulationapps
                                              asset:///settings/hce/AidDefaults.qml
                                              
                                              Default Apps
                                              settings://defaultapps
                                              asset:///settings/appmgr/UserDefaults.qml
                                              icons/ca_default_apps.png
                                              
                                              Installing Apps
                                              settings://appinstall
                                              asset:///settings/appmgr/AppInstall.qml
                                              icons/ca_app_install.png
                                              
                                              Email Confirmation
                                              settings://bbid/confEmailChallenge
                                              asset:///settings/bbid/ConfEmailChallenge.qml
                                              
                                              Quick Settings
                                              settings://quicksettings
                                              asset:///settings/quicksettings/QuickSettings.qml
                                              icons/ca_quick_settings.png
                                              
                                              Date of Birth
                                              settings://bbid/BBIDDobChallenge
                                              asset:///settings/bbid/BBIDDobChallenge.qml
                                              
                                              Advanced Interaction
                                              settings://advancedInteraction
                                              asset:///settings/sensor/AdvancedInteraction.qml
                                              icons/ca_advanced_interaction.png
                                              
                                              
                                              VPN AnyConnect Logs
                                              settings://vpn/VpnProfileLogPage
                                              asset:///settings/vpn/VpnProfileLogPage.qml

                     */
                }
            }
        }
    }
}