import bb.cascades 1.2
import "../CustomElements"
import "../SettingsElements"

Sheet {
    id: settingsSheet
    
    onClosed: { destroy() }

    peekEnabled: false
    
    Page {
        titleBar: TitleBar {
            title: qsTr("Settings") + Retranslate.onLocaleOrLanguageChanged
            acceptAction: ActionItem {
                title: qsTr("OK") + Retranslate.onLocaleOrLanguageChanged
                onTriggered: { settingsSheet.close() }
            }
        }

        Container {
            id: settingsMainContainer
            layout: DockLayout {}
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            
            attachedObjects: [ LayoutUpdateHandler { id: settingsMainContainerLuh }]
            
            AnimatedBackground {}
            ScrollView {
                id: scrollView
                scrollRole: ScrollRole.Main
                Container {
                    id: settingsContainer
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    topPadding: _ui.du(3)
                    bottomPadding: topPadding
                    leftPadding: topPadding
                    rightPadding: topPadding
                    
                    minWidth: settingsMainContainerLuh.layoutFrame.width
                    minHeight: settingsMainContainerLuh.layoutFrame.height
                    
                    property int doubleTapCounter: 0
                    property int longPressCounter: 0
                    gestureHandlers: [
                        LongPressHandler {
                            onLongPressed: {
                                settingsContainer.longPressCounter++
                                if (settingsContainer.longPressCounter >= 5) {
                                    _settings.setValue("isRoger", true)
                                    systemToast.body = "Shutdown bar enabled, restart require"
                                    systemToast.show()
                                    settingsContainer.longPressCounter = 0
                                }
                            }
                        },
                        DoubleTapHandler {
                            onDoubleTapped: {
                                settingsContainer.doubleTapCounter++
                                if (settingsContainer.doubleTapCounter >= 5) {
                                    _settings.remove("tipsShown")
                                    _settings.remove("dooCount")
                                    systemToast.body = "Tutorial reset"
                                    systemToast.show()
                                    settingsContainer.doubleTapCounter = 0
                                }
                            }
                        }
                    ]
                    
                    DoubleClickIntervalContainer {}
                    LongPressIntervalContainer {}
                    WeatherContainer {}
                    NotificationsEnabledContainer {}
                    LedEnabledContainer {}
                    KeypadFlashEnabledContainer {}
                    PlaySoundEnabledContainer {}
                    ClearClipboardContainer {}
                    DisableButtonsWhenMediaPlayerActiveContainer {}
                    LanguageContainer {}
                }
            }
        }
    }
}        
