import bb.cascades 1.2
import "Sheets"

Page {
    id: cardPage
    
    attachedObjects: [
        AppCover { id: activeFrame },
        ComponentDefinition { id: dooNoteSheet; DooNoteSheet {} },
        RenderFence {
            raised: true
            onReached: {
                _app.handlePendingDoo()
            }
        }
    ]
    
    onCreationCompleted: {
        Application.menuEnabled = false
        
        // Creates a MultiCover or SceneCover depending on asset selection
        Application.setCover(activeFrame)
        
        _app.dooNoteRequest.connect(onDooNoteRequest)
    }

    function onDooNoteRequest() {
        var createdControl = dooNoteSheet.createObject(cardPage)
        createdControl.closed.connect(onDooNoteSheetClosed)
        createdControl.open()
    }
    
    function onDooNoteSheetClosed() {
        console.log("onDooNoteSheetClosed()")
        Application.quit()
    }
    
    Container {
        layout: DockLayout {}
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill

        ImageView {
            imageSource: "asset:///Images/icon_1064.png"
            scalingMethod: ScalingMethod.AspectFit
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
        }
    }
}
